#! /usr/bin/env python
# -*- coding: utf-8 -*-

import os.path as osp
import shutil
import sys
import tempfile
import zipfile

# Find casa_distro module path relatively to this file according to source
# files organization. Adds it to the begining of sys.path if found.
ppath = osp.join(osp.dirname(osp.dirname(osp.realpath(__file__))), 'python')
if osp.exists(osp.join(ppath, 'casa_distro', '__init__.py')):
    sys.path.insert(0, ppath)
del ppath

from casa_distro.command import main
from casa_distro import user_commands

tmp_share = None
try:
    # Manage share directory in Zip file distribution
    if not osp.exists(__file__) and osp.dirname(__file__).endswith('.zip'):
        tmp_share = tempfile.mkdtemp()
        with zipfile.ZipFile(osp.dirname(__file__)) as zip:
            for i in zip.namelist():
                if i.startswith('share'):
                    zip.extract(i, tmp_share)
        import casa_distro
        casa_distro.share_directory = osp.join(tmp_share, 'share')

    main()
finally:
    if tmp_share:
        shutil.rmtree(tmp_share)
